<?php
/**
 * @filename TokenizerInterface.php
 * @author Jerry Yan <792602257@qq.com>
 * @date 2020/12/17 15:22
 */


namespace JerryYan\DSL\Tokenizer;


use JerryYan\DSL\Reader\ReaderInterface;
use JerryYan\DSL\Token\TokenInterface;

abstract class TokenizerInterface
{

    protected $tokenFactory;
    /**
     *
     * @param ReaderInterface $reader
     * @return ?TokenInterface
     * @author Jerry Yan <792602257@qq.com>
     * @date 2020/12/18 11:43
     */
    abstract function tokenize(ReaderInterface $reader): ?TokenInterface;
}